SimpleContentModel (Xerces2 Implementation)
Date: 2018-10-17

org.apache.xerces.impl.dtd.models

## Class SimpleContentModel

- java.lang.Object
- - org.apache.xerces.impl.dtd.models.SimpleContentModel

- All Implemented Interfaces:
    ContentModelValidator

      public class SimpleContentModel
      extends java.lang.Object
      implements ContentModelValidator

  SimpleContentModel is a derivative of the abstract content model base class that handles a small set of simple content models that are just way overkill to give the DFA treatment.

  This class handles the following scenarios:

  - a
  - a?
  - a*
  - a+
  - a,b
  - a|b

  These all involve a unary operation with one element type, or a binary operation with two elements. These are very simple and can be checked in a simple way without a DFA and without the overhead of setting up a DFA for such a simple check.

  Version:
    $Id: SimpleContentModel.java 699892 2008-09-28 21:08:27Z mrglavas $

  # INTERNAL:

    Usage of this class is not supported. It may be altered or removed at any time.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static short` | `CHOICE` CHOICE
    `static short` | `SEQUENCE` SEQUENCE

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SimpleContentModel(short operator, org.apache.xerces.xni.QName firstChild, org.apache.xerces.xni.QName secondChild)` Constructs a simple content model.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `validate(org.apache.xerces.xni.QName[] children, int offset, int length)` Check that the specified content is valid according to this content model.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### CHOICE

          public static final short CHOICE

      CHOICE
      See Also:
        Constant Field Values

    - #### SEQUENCE

          public static final short SEQUENCE

      SEQUENCE
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### SimpleContentModel

          public SimpleContentModel(short operator,
                                    org.apache.xerces.xni.QName firstChild,
                                    org.apache.xerces.xni.QName secondChild)

      Constructs a simple content model.
      Parameters:
        `operator` - The content model operator.
        `firstChild` - qualified name of the first child
        `secondChild` - qualified name of the second child

  - ### Method Detail

    - #### validate

          public int validate(org.apache.xerces.xni.QName[] children,
                              int offset,
                              int length)

      Check that the specified content is valid according to this content model. This method can also be called to do 'what if' testing of content models just to see if they would be valid.

      A value of -1 in the children array indicates a PCDATA node. All other indexes will be positive and represent child elements. The count can be zero, since some elements have the EMPTY content model and that must be confirmed.

      Specified by:
        `validate` in interface `ContentModelValidator`
      Parameters:
        `children` - The children of this element. Each integer is an index within the `StringPool` of the child element name. An index of -1 is used to indicate an occurrence of non-whitespace character data.
        `offset` - Offset into the array where the children starts.
        `length` - The number of entries in the `children` array.
      Returns:
        The value -1 if fully valid, else the 0 based index of the child that first failed. If the value returned is equal to the number of children, then the specified children are valid but additional content is required to reach a valid ending state.

Copyright © 1999-2010 The Apache Software Foundation. All Rights Reserved.